scala.tools.nsc.ast.parser.Scanners

# Scanner

#### abstract class Scanner extends CharArrayReader with TokenData with ScannerData with ScannerCommon

Source
  Scanners.scala

Linear Supertypes
Scanners.ScannerCommon, ScannerData, TokenData, Scanners.CommonTokenData, CharArrayReader, CharArrayReaderData, AnyRef, Any
Known Subclasses
ParensAnalyzer, SourceFileScanner, UnitScanner
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Scanner
2. ScannerCommon
3. ScannerData
4. TokenData
5. CommonTokenData
6. CharArrayReader
7. CharArrayReaderData
8. AnyRef
9. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Scanner()

### Type Members

1. #### class CharArrayLookaheadReader extends CharArrayReader

   Definition Classes
     CharArrayReader

### Abstract Value Members

1. #### abstract val buf: Array[Char]

   Definition Classes
     CharArrayReader

2. #### abstract def deprecationWarning(off: Scanners.Offset, msg: String): Unit

   Definition Classes
     ScannerCommon

3. #### abstract def error(off: Scanners.Offset, msg: String): Unit

   Definition Classes
     ScannerCommon

4. #### abstract def incompleteInputError(off: Scanners.Offset, msg: String): Unit

   Definition Classes
     ScannerCommon

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Scanner to any2stringadd[Scanner] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Scanner, B)

   Implicit information
     This member is added by an implicit conversion from Scanner to ArrowAssoc[Scanner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def applyBracePatch(): Boolean

   overridden in UnitScanners: apply brace patch if one exists for this offset return true if subsequent end of line handling should be suppressed.

7. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

8. #### var base: Int

   the base of a number

   the base of a number

   Definition Classes
     TokenData

9. #### val cbuf: collection.mutable.StringBuilder

   A character buffer for literals

10. #### var ch: Char

    the last read character

    the last read character

    Definition Classes
      CharArrayReaderData

11. #### def charLitOr(op: () ⇒ Unit): Unit

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

12. #### var charOffset: Int

    The offset one past the last read character

    The offset one past the last read character

    Definition Classes
      CharArrayReaderData

13. #### def charVal: Char

    Convert current strVal to char value

14. #### def checkNoLetter(): Unit

15. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

16. #### def copyFrom(sd: ScannerData): Scanner.this.type

    Definition Classes
      ScannerData

17. #### def copyFrom(td: TokenData): Scanner.this.type

    Definition Classes
      TokenData

18. #### def copyFrom(cd: CharArrayReaderData): Scanner.this.type

    Definition Classes
      CharArrayReaderData

19. #### def decodeUni: Boolean

    Definition Classes
      CharArrayReader

20. #### def deprecationWarning(msg: String): Unit

21. #### def discardDocBuffer(): Unit

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

22. #### def emitIdentifierDeprecationWarnings: Boolean

    Determines whether this scanner should emit identifier deprecation warnings, e.g.

    Determines whether this scanner should emit identifier deprecation warnings, e.g. when seeing `macro` or `then`, which are planned to become keywords in future versions of Scala.

    Attributes
      protected

23. #### def ensuring(cond: (Scanner) ⇒ Boolean, msg: ⇒ Any): Scanner

    Implicit information
      This member is added by an implicit conversion from Scanner to Ensuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

24. #### def ensuring(cond: (Scanner) ⇒ Boolean): Scanner

    Implicit information
      This member is added by an implicit conversion from Scanner to Ensuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

25. #### def ensuring(cond: Boolean, msg: ⇒ Any): Scanner

    Implicit information
      This member is added by an implicit conversion from Scanner to Ensuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### def ensuring(cond: Boolean): Scanner

    Implicit information
      This member is added by an implicit conversion from Scanner to Ensuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

28. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

29. #### final def fetchToken(): Unit

    read next token, filling TokenData fields of Scanner.

    read next token, filling TokenData fields of Scanner.

    Attributes
      protected

30. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

31. #### def floatVal: Double

32. #### def floatVal(negated: Boolean): Double

    Convert current strVal, base to double value

33. #### def flushDoc(): Global.DocComment

34. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Scanner to StringFormat[Scanner] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

35. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

36. #### def getFraction(): Unit

    read fractional part and exponent of floating point number if one is present.

    read fractional part and exponent of floating point number if one is present.

    Attributes
      protected

37. #### def getLitChar(): Unit

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    Attributes
      protected

38. #### def getNumber(): Unit

    Read a number into strVal and set base

    Read a number into strVal and set base

    Attributes
      protected

39. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

40. #### def healBraces(): List[BracePatch]

    overridden in UnitScanners

41. #### def inFirstOfStat(token: Scanners.Token): Boolean

    Can token start a statement?

42. #### def inLastOfStat(token: Scanners.Token): Boolean

    Can token end a statement?

43. #### def incompleteInputError(msg: String): Unit

    signal an error where the input ended in the middle of a token

44. #### def init(): Unit

    Initialization method: read first char, then first token

45. #### def intVal: Long

46. #### def intVal(negated: Boolean): Long

    Convert current strVal, base to long value This is tricky because of max negative value.

47. #### def invalidEscape(): Unit

    Attributes
      protected

48. #### def isAtEnd: Boolean

49. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

50. #### def isUnicodeEscape: Boolean

    Is last character a unicode escape \\uxxxx?

    Is last character a unicode escape \\uxxxx?

    Definition Classes
      CharArrayReader

51. #### var lastLineStartOffset: Int

    The start offset of the line before the current one

    The start offset of the line before the current one

    Definition Classes
      CharArrayReaderData

52. #### var lastOffset: Scanners.Offset

    the offset of the character following the token preceding this one

    the offset of the character following the token preceding this one

    Definition Classes
      TokenData

53. #### var lastUnicodeOffset: Int

    Attributes
      protected
    Definition Classes
      CharArrayReaderData

54. #### var lineStartOffset: Int

    The start offset of the current line

    The start offset of the current line

    Definition Classes
      CharArrayReaderData

55. #### def lookaheadReader: CharArrayLookaheadReader

    A new reader that takes off at the current character position

    A new reader that takes off at the current character position

    Definition Classes
      CharArrayReader

56. #### var name: Global.TermName

    the name of an identifier

    the name of an identifier

    Definition Classes
      TokenData → CommonTokenData

57. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

58. #### val next: TokenData

    we need one token lookahead and one token history

    we need one token lookahead and one token history

    Definition Classes
      ScannerData

59. #### final def nextChar(): Unit

    Advance one character; reducing CR;LF pairs to just LF

    Advance one character; reducing CR;LF pairs to just LF

    Definition Classes
      CharArrayReader

60. #### final def nextRawChar(): Unit

    Advance one character, leaving CR;LF pairs intact.

    Advance one character, leaving CR;LF pairs intact. This is for use in multi-line strings, so there are no "potential line ends" here.

    Definition Classes
      CharArrayReader

61. #### def nextToken(): Unit

    Produce next token, filling TokenData fields of Scanner.

62. #### def nextTokenAllow(name: Global.Name): Unit

    Get next token, and allow the otherwise deprecated ident `name`

63. #### final def notify(): Unit

    Definition Classes
      AnyRef

64. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

65. #### var offset: Scanners.Offset

    the offset of the first character of the current token

    the offset of the first character of the current token

    Definition Classes
      TokenData

66. #### def parenBalance(token: Scanners.Token): Int

    overridden in UnitScanners

67. #### val prev: TokenData

    Definition Classes
      ScannerData

68. #### def putChar(c: Char): Unit

    append Unicode character to "cbuf" buffer

    append Unicode character to "cbuf" buffer

    Attributes
      protected

69. #### def putCommentChar(): Unit

    Attributes
      protected

70. #### def resume(lastCode: Scanners.Token): Unit

71. #### var sepRegions: List[Scanners.Token]

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels.

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels. We keep track of the closing symbol of a region. This can be RPAREN if region starts with '(' RBRACKET if region starts with '[' RBRACE if region starts with '{' ARROW if region starts with `case' STRINGLIT if region is a string interpolation expression starting with '${' (the STRINGLIT appears twice in succession on the stack iff the expression is a multiline string literal).`

72. #### def skipBlockComment(): Unit

73. #### def skipComment(): Boolean

74. #### def skipDocComment(): Unit

75. #### final def skipNestedComments(): Unit

    Annotations
      @tailrec()

76. #### def skipToken(): Scanners.Offset

    read next token and return last offset

77. #### var strVal: String

    the string value of a literal

    the string value of a literal

    Definition Classes
      TokenData

78. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

79. #### def syntaxError(msg: String): Unit

    generate an error at the current token offset

80. #### def syntaxError(off: Scanners.Offset, msg: String): Unit

    generate an error at the given offset

81. #### def toString(): String

    Definition Classes
      Scanner → AnyRef → Any

82. #### var token: Scanners.Token

    the next token

    the next token

    Definition Classes
      TokenData → CommonTokenData

83. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

84. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

85. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

86. #### def →[B](y: B): (Scanner, B)

    Implicit information
      This member is added by an implicit conversion from Scanner to ArrowAssoc[Scanner] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Scanners.ScannerCommon

### Inherited from ScannerData

### Inherited from TokenData

### Inherited from Scanners.CommonTokenData

### Inherited from CharArrayReader

### Inherited from CharArrayReaderData

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Scanner to any2stringadd[Scanner]

### Inherited by implicit conversion StringFormat from Scanner to StringFormat[Scanner]

### Inherited by implicit conversion Ensuring from Scanner to Ensuring[Scanner]

### Inherited by implicit conversion ArrowAssoc from Scanner to ArrowAssoc[Scanner]

### Ungrouped